<?php

  require_once("Classes/DataBase.class.php");
  require_once("Classes/Template.class.php");

  // actions
  $db = new DataBase();
  if(isset($_REQUEST['postback'])) {
    $MYSQLCONFIG = array(
      'host'=>$_REQUEST["host"],
      'user'=>$_REQUEST["user"],
      'password'=>$_REQUEST["password"],
      'database'=>$_REQUEST["database"]
    );
    setConfiguration("Includes/config.inc.php", $MYSQLCONFIG);
  }

  $courses = array();
  if ($db->isConnected() && isset($_REQUEST['dbinstall'])) {
    parse_mysql_dump("Sql/dbsetup.sql");
    $db->setConfiguration();
    header("location: import.php");
    exit(0);
  }
  if ($db->isComplete()) {
    $courses = $db->getCourses();
  }

  // BUILD PAGE
  $tpl = new Template("templates/");
  // set files and blocks
  $tpl->set_file("page_tp", "page.tpl");
  $tpl->set_block("page_tp", "LICOURSE", "licourses");
  $tpl->set_file("setup_tp", "setup.tpl");
  $tpl->set_block("setup_tp", "HEADBLOCK", "headblock");
  $tpl->set_block("setup_tp", "CONTENTBLOCK", "contentblock");
  $tpl->set_var("ACTION", $_SERVER['PHP_SELF']);
  // set values
  $tpl->set_var("HOST", $MYSQLCONFIG['host']);
  $tpl->set_var("USER", $MYSQLCONFIG['user']);
  $tpl->set_var("DATABASE", $MYSQLCONFIG['database']);
  $tpl->set_var("URLINSTALL", $_SERVER['PHP_SELF']."?dbinstall");
  $tpl->set_var("TXT_INSTALL", $db->isComplete()?"Reset Database":"Install Database");

  // generate page
  foreach ($courses as $course) {
    $tpl->set_var("NAME_LICOURSE", $course->getName());
    $tpl->set_var("URL_LICOURSE",  "showCourse.php?courseId=".$course->getId());
    $tpl->parse("licourses",  "LICOURSE", true);
  }
  $tpl->set_var("TITLE", "StudentsWatch - setup");
  $tpl->parse("HEADEXTRA", "HEADBLOCK");
  $tpl->parse("CONTENT", "CONTENTBLOCK");
  $tpl->pparse("htmlcode", "page_tp");

?>

