﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Descripción breve de DataLoadClass
/// </summary>
public class DataLoadClass
{
    private static Excel.ApplicationClass oExcel;
    private static Excel._Workbook oBook;
    private static Excel.Sheets oSheets;
    private static Excel.Worksheet oSheet;
    object missing = System.Reflection.Missing.Value;
	
    public DataLoadClass()
	{
        oExcel = new Excel.ApplicationClass();
    }

    public Excel.Worksheet LoadDocument(string name,bool show)
    {

        try
        {
            
            oExcel.Visible = show;
            oBook = oExcel.Workbooks.Open(name, missing, false, missing, missing, missing, missing, missing, missing, true, missing, missing, missing, missing, missing);
            //cogemos la hoja1
            oSheets = oBook.Sheets;
            oSheet = (Excel.Worksheet)oSheets.get_Item(1);
        }
            
        catch (Exception ex)
        {
            throw ex;
        }
        return oSheet;
    }
    public void LoadData(/*,Label Label3*/)
    {
        //oExcel = new Excel.ApplicationClass();
        //LoadDocument(name,false);

        string A, oldA, B, D, E,day, month, year;;
        Course course = new Course();
        Student_info student = new Student_info();
        Course_activity ca = new Course_activity();
        Student_courseactivity st_courseactivity = new Student_courseactivity();
        Week_eval week = new Week_eval();
        oldA = "";
        bool more = true;
        int i = 2;
        B = null;
        
        DataBaseClass db = new DataBaseClass();
        try
        {
            while (more)
            {
                A = (string)oSheet.get_Range("A" + i, missing).Text;

                if (A != "")//course name 
                {
                    if (!A.Equals(oldA))//course didn't exists in this document
                    {
                        oldA = A;
                        //Label3.Text = course.getCoursename();
                        course = db.FindCourse(A.Trim());
                        if (course == null)
                        {
                            course = new Course(A.Trim());
                            db.InsertCourse(course);
                            course = db.FindCourse(course.getCoursename());//set new id in course                         
                            //Label3.Text = Label3.Text+"Course:" + A + " INSERTET IN DATABASE";
                        }
                        //Label3.Text = Label3.Text + "Class: X";
                        B = "X";

                    }
                    else//A==oldA
                    {
                        B = (string)oSheet.get_Range("B" + i, missing).Text;
                        //Label3.Text = Label3.Text + "Class: " + B;
                    }

                }
                else//A=="" looking for Students
                {
                    D = (string)oSheet.get_Range("D" + i, missing).Text;
                    E = (string)oSheet.get_Range("E" + i, missing).Text;
                    E = E.Remove(0, 11);

                    if (E.Substring(0, 2).Contains("/"))//case simple day (ex: 1/10/2000)
                    {
                        day = E.Substring(0, 1);
                        month = E.Substring(2, 2);
                        year = E.Substring(5, 4);
                    }
                    else
                    {
                        day = E.Substring(0, 2);
                        month = E.Substring(3, 2);
                        year = E.Substring(6, 4);
                    }
                    DateTime birth = new DateTime(Convert.ToInt16(year), Convert.ToInt16(month), Convert.ToInt16(day));
                    //Label3.Text = Label3.Text + " "+D +" birth:" + E;
                    student = db.FindStudent(D, birth);
                    if (student == null)
                    {
                        student = new Student_info(D, birth);
                        //insert student in DataBase
                        db.InsertStudent(student);
                        student = db.FindStudent(student.getStudentname(), birth);//set new student id
                        //Label3.Text = Label3.Text + "Student doesn't exists in Database";

                    }
                    //insert all classes
                    ca.setCourseid(course.getCourseid());
                    ca.setStudentid(student.getStudentid());
                    //inserting courseActivity in DAtabase
                    db.InsertCourseActivity(ca);
                    st_courseactivity.setCourseid(course.getCourseid());
                    st_courseactivity.setStudentid(student.getStudentid());
                    st_courseactivity.setClassroom(B);
                    //inserting studentcourseactivity in database
                    db.InsertStudentCourseActivity(st_courseactivity);

                }
                //looking new line
                i++;
                A = (string)oSheet.get_Range("A" + i, missing).Text;
                D = (string)oSheet.get_Range("D" + i, missing).Text;
                E = (string)oSheet.get_Range("E" + i, missing).Text;
                if (A == "" && D == "" && E == "")//if line is empty
                {
                    more = false;//exit
                }
            }
            CloseApplication();
        }
        catch (Exception ex)
        {
            throw ex;
        }

    
	}
    public void CloseApplication()
    {
        /*System.Runtime.InteropServices.Marshal.ReleaseComObject(oSheet);
        oSheet = null;

        System.Runtime.InteropServices.Marshal.ReleaseComObject(oSheets);
        oSheets = null;*/

        oBook.Close(false, missing, missing);
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oBook);
        oBook = null;

        oExcel.Quit();
        System.Runtime.InteropServices.Marshal.ReleaseComObject(oExcel);
        oExcel = null;
    }
}
