﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ShowCourse : System.Web.UI.Page
{
    private static int gridrow;
    private static int gridcol;
    private static System.Drawing.Color color;
    private static int colorid;
    private static DataTable students;
    private static bool save=false;
    
    protected void Page_Load(object sender, EventArgs e)
    {
       
            Label1.Text = Request["coursename"];
            DataBaseClass dbc = new DataBaseClass();
            Course course = dbc.FindCourse(Request["coursename"]);
            if (!Page.IsPostBack || save)//to paint not edited added weeks in students 
            {
                students = dbc.FindStudentsInCourse(course);
                save = false;
            }
            GridView1.DataSource = new DataView(students);
          
            GridView1.DataBind();
            PaintingCells();
 }
    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
   

    }
    public void PaintingCells()
    {

        Button b;
        for (int i = 0; i < GridView1.Rows.Count; i++)
        {
           

            for (int j = 3; j < GridView1.Rows[i].Cells.Count; j++)
            {
                color = System.Drawing.Color.FromArgb(255, 255, 255);
                //birth format
                DateTime Fecha = Convert.ToDateTime(GridView1.Rows[i].Cells[2].Text);
                GridView1.Rows[i].Cells[2].Text = Fecha.ToShortDateString();

                if (GridView1.Rows[i].Cells[j].Text.Equals("1"))
                {
                    color = System.Drawing.Color.FromArgb(204, 0, 0);
                }
                if (GridView1.Rows[i].Cells[j].Text.Equals("2"))
                {      
                    color=System.Drawing.Color.FromArgb(255, 101, 0);
                }
                if (GridView1.Rows[i].Cells[j].Text.Equals("3"))
                {
                    color=System.Drawing.Color.FromArgb(255, 204, 51);
                }
                if (GridView1.Rows[i].Cells[j].Text.Equals("4"))
                {
                    color=System.Drawing.Color.FromArgb(153, 204, 51);
                }
                if (GridView1.Rows[i].Cells[j].Text.Equals("5"))
                {
                    color = System.Drawing.Color.FromArgb(10, 253, 0);
                }
                //adds button in cell
                b = new Button();
                b.ForeColor = color;
                b.Text = i + "," + j;//textbutton= (row , col) ---> to know cell on click
                b.Click += new EventHandler(Edit);
                b.BorderWidth = new Unit(1);
                b.Width = new Unit(100, UnitType.Percentage);
                b.Height = new Unit(100, UnitType.Percentage);
                b.BackColor =color;
                b.BorderColor = color;
                GridView1.Rows[i].Cells[j].Controls.Add(b); 
                GridView1.Rows[i].Cells[j].BackColor = color;
                GridView1.Rows[i].Cells[j].BorderWidth = new Unit(1);
                GridView1.Rows[i].Cells[j].BorderColor = System.Drawing.Color.Black;
            }
        }
    }
    /*private void PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
       // GridView1.PageIndex = e.NewPageIndex;
    
        //PaintingCells();
        //GridView1.DataBind();

    }
        private void PageIndexChanged(object sender, EventArgs e)
    {
        //Page_Load(sender, e);
        //PaintingCells();
    }*/

    protected void Button1_Click(object sender, EventArgs e)
    {
        Panel1.Visible = false;
    }
    public void Edit(object sender,EventArgs e)

    {
        DataBaseClass dbc = new DataBaseClass();
       
        //show to mark panel new cell(week)
        Button b = (Button)sender;
        int row = Convert.ToInt16(b.Text.Substring(0, b.Text.IndexOf(",")));
        int col = Convert.ToInt16(b.Text.Substring(b.Text.IndexOf(",")+1));
        gridrow= row;
        gridcol=col;
        //find week_eval to edit
        Week_eval week=dbc.FindWeek(col-2,Convert.ToInt16(GridView1.Rows[row].Cells[0].Text));
        if (week == null)
        {
            TextBox1.Text = "";
        }
        else
        {
            TextBox1.Text = week.getComments();
        }
        Panel1.Visible = true;
        //shows selected cell in blue
        GridView1.Rows[gridrow].Cells[gridcol].BorderColor = System.Drawing.Color.Blue;
        GridView1.Rows[gridrow].Cells[gridcol].BorderWidth = new Unit(3);
        Button7.BackColor = GridView1.Rows[gridrow].Cells[gridcol].BackColor;
    }

    public void ChangeMark()
    {      
        Button7.BackColor = color;
        GridView1.Rows[gridrow].Cells[gridcol].BackColor = color;
        Button bb = (Button)GridView1.Rows[gridrow].Cells[gridcol].Controls[0];
        bb.BackColor = color;
        bb.BorderColor = color;
        bb.ForeColor = color;
        GridView1.Rows[gridrow].Cells[gridcol].BorderColor = System.Drawing.Color.Blue;
        GridView1.Rows[gridrow].Cells[gridcol].BorderWidth = new Unit(3);

       

    }
    protected void Button4_Click(object sender, EventArgs e)
    {
        color = Button4.BackColor;
        colorid = 3;
        ChangeMark();
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        color = Button2.BackColor;
        colorid = 5;
        ChangeMark();
    }
    protected void Button3_Click(object sender, EventArgs e)
    {
        color = Button3.BackColor;
        colorid = 4;
        ChangeMark();
    }
    protected void Button5_Click(object sender, EventArgs e)
    {
        color = Button5.BackColor;
        colorid = 2;
        ChangeMark();
    }
    protected void Button6_Click(object sender, EventArgs e)
    {
        color = Button6.BackColor;
        colorid = 1;
        ChangeMark();
    }
    protected void Button8_Click(object sender, EventArgs e)
    {
        try
        {

            DataBaseClass dbc = new DataBaseClass();
            int studentid = Convert.ToInt16(GridView1.Rows[gridrow].Cells[0].Text);
            Week_eval w = dbc.FindWeek(gridcol - 2, studentid);

            //saving changes of mark panel
            if (w != null)//if week exists on database
            {
                w.setWeekmark(colorid);
                w.setComments(TextBox1.Text);
                dbc.UpdateWeek(w);
            }
            else//new week
            {
                Course c = dbc.FindCourse(Label1.Text);
                w = new Week_eval(studentid, colorid, gridcol - 2, c.getCourseid(), TextBox1.Text);
                dbc.InsertWeek(w);
            }
            save = true;
            Page_Load(sender,e);
        }
       
        catch (Exception ex)
        {
            Label2.Text = ex.ToString();
            throw ex ;
        }
    }

    protected void Button9_Click1(object sender, EventArgs e)
    {
        students.Columns.Add(new DataColumn(/*"Week " +*/ (GridView1.Rows[0].Cells.Count - 2).ToString()));
        GridView1.DataSource = new DataView(students);
        GridView1.DataBind();
        PaintingCells();
    }
}
