function findChildNodes(parent, tagname) {
  var nodes = new Array();
  for (var i=0; i<parent.childNodes.length; i++) {
    child = parent.childNodes[i];
    if (child.nodeName==tagname.toUpperCase()) {
      nodes.push(child);
    }
    nodes = nodes.concat(findChildNodes(child, tagname));
  }
  return nodes;
}

function findQueryPar(query, name) {
  var arrPars = query.split("&");
  for (var i=0; i<arrPars.length; i++) {
    var arrChunks = arrPars[i].split("=");
    if (arrChunks[0]==name) return arrChunks[1];
  }
  return undefined;
}

function addSFEvents(hoverMenuId, hoverClass) {
  if (!hoverMenuId) return;
  if (!document.getElementById(hoverMenuId)) return;
  if (!hoverClass)  hoverClass  = " over";
  var sfEls = document.getElementById(hoverMenuId).getElementsByTagName("LI");
  for (var i=0; i<sfEls.length; i++) {
    sfEls[i].onmouseover=function() {
      this.className+=hoverClass;
    }
    sfEls[i].onmouseout=function() {
      this.className = this.className.replace(hoverClass.trim(), "").trim();
    }
  }
}

function addLoadEvents(func) {
  var oldonload = window.onload;
  if (typeof window.onload != 'function'){
    window.onload = func;
  } else {
    window.onload = function(){
      oldonload();
      func();
    }
  }
}

String.prototype.trim = function() {
  return this.replace(/\s*((\S+\s*\S+)*)\s*/, "$1")
}


