﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{

    DataLoadClass dlc = new DataLoadClass();
    static string file;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            DataBaseClass dbc = new DataBaseClass();
            DataTable dt = dbc.FindAllCourses();
            foreach (DataRow menuItem in dt.Rows)
            {

                MenuItem men = new MenuItem(menuItem["coursename"].ToString(), menuItem["courseid"].ToString());

                Menu1.Items[2].ChildItems.Add(men);
            }
        }

    }

    public void Button1_Click(object sender, EventArgs e)
    {
        file = "C:\\Windows\\Temp\\" + FileUpload1.FileName;
       
        
        try
        {
            FileUpload1.SaveAs(file);
            dlc.LoadDocument(file,CheckBox1.Checked);
            Label3.ForeColor = System.Drawing.Color.LimeGreen;
            Label3.Text = "Document " + file+ " found!";
            Button2.Enabled = true;
            Button1.Enabled = false;
            FileUpload1.Enabled = false;
            Button3.Enabled = true;
            
        }
        catch (Exception ex)
        {
            Label3.Text = ex.ToString(); 
        }
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        Label3.Text = "Loading data....";
         try
        {
            dlc.LoadData();
            Label3.ForeColor = System.Drawing.Color.LimeGreen;
            Label3.Text = "Data loaded in DataBase!";
            Button1.Enabled = true;
            Button2.Enabled = false;
            FileUpload1.Enabled = true;
            Button3.Enabled = false;
        }
        catch (Exception ex)
        {
            Label3.Text = ex.ToString();
        }
    }




    protected void Button3_Click(object sender, EventArgs e)
    {
        dlc.CloseApplication();
        Button1.Enabled = true;
        Button2.Enabled = false;
        FileUpload1.Enabled = true;
        Button3.Enabled = false;

        Label3.ForeColor = System.Drawing.Color.Red;
        Label3.Text = "Cancelled by user";
    }
    protected void Menu1_MenuItemClick(object sender, MenuEventArgs e)
    {

    }
}
