﻿<?
//include ("Course.php");
include ("StudentCourseActivity.class.php");
include ("StudentInfo.class.php");
include ("CourseActivity.class.php");
include ("DataBase.class.php");
include ("Config.inc.php");

//basic functions

  function endsWith($haystack, $needle) {
    return (substr($haystack, strlen($haystack) - strlen($needle)) == $needle);
  }

  function isCsv($file) {
    $file = strtolower($file);
    if (endsWith($file, ".csv")) return true;
    return false;
  }

 function findDate($string) {
   $d = explode(" ", $string);
   $dformat=explode("/",$d[2]);
   $year=trim($dformat[2]);
   $dformat[2]=$dformat[0];
   $dformat[0]=$year;
  return implode("/",$dformat);
  }



$myTempDir = "C:/WINDOWS/Temp/";
 if (!empty($_FILES['search'])) {
    $fileToCopy = $_FILES["search"]["tmp_name"];
    $fileName   = $_FILES["search"]["name"]; 
    if(isCsv($fileName))
    { 
    	$copyTo= $myTempDir.$fileName;
    	copy($fileToCopy, $copyTo) or die("can't copy ".$fileName." to ".$myTempDir);
    	loadData($copyTo);
    }
    else
    {
    	die("ERROR : This is not a CSV file!");
  	}
  }
  
//FUNCTION TO LOAD DATA

	function loadData($csv)
	{
		$data=file($csv)or die("Can't load data from" .$csv);
		$i=1;
		$db=new DataBase();
		while($i<count($data))//for each row in csv file
		{
			$cells = explode(";", $data[$i]);	
			if($cells[0]!="")//case new course
			{	
				$stcourseact=new StudentCourseActivity();
				if($cells[1]=="")//case class x
					{				
						$c=new Course();
						$c->setCourseName($cells[0]);
						if($db->FindCourse($c)==null)
						{
							$db->InsertCourse($c);
						}
						$c=$db->FindCourse($c); //setting course id
						$stcourseact->setClass("X");
					}
				else //case class name
					{
						$stcourseact->setClass($cells[1]);
					}	
			}
			else //case student
			{				
				$student=new StudentInfo();
				$student->setName($cells[3]);
				$student->setBirth(findDate($cells[4]));	
				if($db->FindStudent($student)==null)
				{	
					$db->InsertStudent($student);
					$student=$db->FindStudent($student);//setting studentid		
				}		
				$courseactivity=new CourseActivity();
				$courseactivity->setIdStudent($student->getIdStudent());
				$courseactivity->setIdCourse($c->getIdCourse());
				
				if($db->FindCourseActivity($courseactivity)==null)
				{
					$db->InsertCourseActivity($courseactivity);
				}
				$stcourseact->setIdCourse($c->getIdCourse());
				$stcourseact->setIdStudent($student->getIdStudent());
				
				if($db->FindStudentCourseActivity($stcourseact)==null)
				{
					$db->InsertStudentCourseActivity($stcourseact);
				}
			}	
			$i++;
		}
	}
	

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<link rel="stylesheet" type="text/css" href="Students_Watcher.css" />
		<link rel="stylesheet" type="text/css" href="Data_Loader.css" />
		<title>STuDenTs WaTcHer</title>
	
<script type="text/javascript"><!--//--><![CDATA[//><!--

sfHover = function() {
	var sfEls = document.getElementById("nav").getElementsByTagName("LI");
	for (var i=0; i<sfEls.length; i++) {
		sfEls[i].onmouseover=function() {
			this.className+=" sfhover";
		}
		sfEls[i].onmouseout=function() {
			this.className=this.className.replace(new RegExp(" sfhover\\b"), "");
		}
	}
}
if (window.attachEvent) window.attachEvent("onload", sfHover);

//--><!]]></script>
	</head>
	<body>
 <div id="header">
    <h1><a href="index.php"><span>Student's Watcher</span></a></h1>
  </div>
     <div id="menu">
      <ul>
        <li><a href="#">Show Courses</a>
      		  <ul>
<?php
	$db=new DataBase();
  $rs=$db->FindAllCourses(); 
  $i=0;
  while($row = mysql_fetch_object($rs))
  {			  	
?> 
            <li><a href="./ShowCourse.php?courseId=<?=$row->courseid?>"><?=$row->coursename?></a></li>
<?  
  }
?>
  			  </ul>
  	  </li>
    <li><a href="./DataLoader.php">Data Loader</a></li>
     </ul>
    </div>
 <div id="content">
	<h2>Data Loader</h2>
  	<form action="<?=$_SERVER['PHP_SELF']?>" method="post" enctype="multipart/form-data">
  	    <div class="formUpload">
          <label for="search">Select Document:</label>
          <input class="text" type="file" name="search" size="35" id="search" />
          <input class="submit" type="submit" class="goBtn" name="btnSearchDocument" Value="Ok" />
        </div>
    </form>
 </div>
	</body>
</html>