
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

DROP TABLE IF EXISTS `STUDENT_INFO`;
CREATE TABLE IF NOT EXISTS `STUDENT_INFO`(
	studentid INTEGER(10) NOT NULL AUTO_INCREMENT, 
	PRIMARY KEY(studentid),
	studentname VARCHAR(255),
	birth DATE not null
	)
	;
DROP TABLE IF EXISTS `COURSE_ACTIVITY`;	
CREATE TABLE IF NOT EXISTS `COURSE_ACTIVITY`(	 
	courseactivityid INTEGER(10) NOT NULL AUTO_INCREMENT,
	PRIMARY KEY(courseactivityid),
	courseid INTEGER(10),
	studentid INTEGER(19)
	)
	;
DROP TABLE IF EXISTS `STUDENT_COURSEACTIVITY`;	
CREATE TABLE IF NOT EXISTS `STUDENT_COURSEACTIVITY`(
	courseid INTEGER(10),
	studentid INTEGER(19), 
	PRIMARY KEY(courseid,studentid),
	class VARCHAR(20)
	)
	;
DROP TABLE IF EXISTS `WEEK_EVAL`;
CREATE TABLE IF NOT EXISTS `WEEK_EVAL`( 
	idweek INTEGER(10) NOT NULL AUTO_INCREMENT, 
	PRIMARY KEY(idweek),
	studentid INTEGER(10),
	weekmark VARCHAR(3),
	weeknr INTEGER(10),
	courseid INTEGER(10),
	comment VARCHAR(255)
	)
	;
DROP TABLE IF EXISTS `COURSE`;
CREATE TABLE IF NOT EXISTS `COURSE`( 
	courseid INTEGER(1) NOT NULL AUTO_INCREMENT, 
	PRIMARY KEY(courseid),
	coursename VARCHAR(255)
	)
	;

